
#-----------------------------------------------------------------------------
# MACRO TO ADD A COMPILER DEFINITION WHICH ADDS ALSO THE DEF 
# INTO DOXYGEN PREDEFINED VAR 
# (OTHERWISE DOXYGEN WOULD NOT PARSE THE FILES BLOCKED)
MACRO(CREA_DEFINE DEF)
  MESSAGE(STATUS "* Added definition -D${DEF}")
  ADD_DEFINITIONS( -D${DEF} )
  SET(DOXYGEN_DOC_PREDEFINED 
    ${DOXYGEN_DOC_PREDEFINED};${DEF}
    CACHE 
    STRING 
    ""
    FORCE)
  MARK_AS_ADVANCED(DOXYGEN_DOC_PREDEFINED)
ENDMACRO(CREA_DEFINE)
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# MACRO TO ADD A COMPILER DEFINITION WITH VALUE WHICH ADDS ALSO THE DEF 
# INTO DOXYGEN PREDEFINED VAR 
# (OTHERWISE DOXYGEN WOULD NOT PARSE THE FILES BLOCKED)
MACRO(CREA_DEFINE_WITH_VAL DEF VAL)
  MESSAGE(STATUS "* Added definition -D${DEF}=\"${VAL}\"")
  ADD_DEFINITIONS( -D${DEF}="${VAL}" )
  SET(DOXYGEN_DOC_PREDEFINED 
    ${DOXYGEN_DOC_PREDEFINED};${DEF}=${VAL}
    CACHE 
    STRING 
    ""
    FORCE)
  MARK_AS_ADVANCED(DOXYGEN_DOC_PREDEFINED)
ENDMACRO(CREA_DEFINE_WITH_VAL)
#-----------------------------------------------------------------------------

