#=======================================================================
# Looks for WxWidgets
#=======================================================================
MACRO(CREA_FIND_WXWIDGETS)
  IF(WIN32)
    # Search WXWIDGETS
    
    #  WXWINDOWS_LIBRARY         = full path to the wxWindows library and linker flags on unix
    #  CMAKE_WX_CXX_FLAGS        = compiler flags for building wxWindows 
    #  WXWINDOWS_INCLUDE_PATH    = include path of wxWindows
    SET(WXWINDOWS_USE_GL 1)
    
    #wxWidgets build related stuff
    SET(WXW_USE_DEBUG ON)
    SET(WXW_USE_UNICODE OFF)
    SET(WXW_USE_SHARED ON)
    SET(WXW_USE_UNIV OFF)
    SET(WXW_USE_MONO OFF)
    SET(WXW_FILE_VERSION "28")
    SET(WXW_VERSION "2.8")
    
    #CMake Options
    # Why forcing verbosity ?
    # SET(CMAKE_VERBOSE_MAKEFILE TRUE)
    
    INCLUDE (${CREA_CMAKE_DIR}/FindWxWidgetsWin32.cmake)
    #
  
  ELSE(WIN32)
    # GTK2
    INCLUDE(${CREA_CMAKE_DIR}/FindGTK2.cmake)
    # WX
    # LG : Do not force but use what is installed !
    # SET(wxWidgets_USE_LIBS base core gl)
    FIND_PACKAGE( wxWidgets REQUIRED) 
    #
    IF(wxWidgets_FOUND)
      MESSAGE(STATUS "Looking for wxWidgets... found ${wxWidgets_CONFIG_EXECUTABLE}")
    ENDIF(wxWidgets_FOUND)
  ENDIF(WIN32)
  


ENDMACRO(CREA_FIND_WXWIDGETS)
#=======================================================================

#=======================================================================
MACRO(CREA_USE_WXWIDGETS)
  # Preprocessor settings
  CREA_DEFINE( USE_WXWIDGETS )
  #
  IF(WIN32)
    # Clean ?
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}${WXWIDGETS_CXX_FLAGS}")
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}${WXWIDGETS_EXE_LINKER_FLAGS}")
    #
    ADD_DEFINITIONS( ${WXWIDGETS_DEFINITIONS}  )
    #
    INCLUDE_DIRECTORIES(${WXWIDGETS_INCLUDE_DIR})
    LINK_DIRECTORIES( ${WXWIDGETS_LINK_DIRECTORIES} )
    SET(WXWIDGETS_LIBRARIES
      ${WXWIDGETS_LIBRARIES}     
      ${WXWIDGETS_LIBRARIES} wxmsw28d_aui      
      debug msvcrtd
      debug msvcprtd
      optimized msvcrt
      optimized msvcprt
      )
  ELSE(WIN32)
    # GTK2
    INCLUDE_DIRECTORIES(${GTK2_INCLUDE_DIRS})
    LINK_DIRECTORIES(${GTK2_LIBRARY_DIRS})
    LINK_LIBRARIES(${GTK2_LIBRARIES})
    # WX
    INCLUDE( ${wxWidgets_USE_FILE} )
    MARK_AS_ADVANCED(wxWidgets_CONFIG_EXECUTABLE)
    SET(WXWIDGETS_LIBRARIES
      ${GTK2_LIBRARIES}
      ${wxWidgets_LIBRARIES}
      )
  ENDIF(WIN32)
ENDMACRO(CREA_USE_WXWIDGETS)
#=======================================================================
